﻿using Microsoft.Win32;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;

namespace AirFusion
{
	public class RegistryUtility
	{
		[DllImport("kernel32.dll", SetLastError = true)]
		[return: MarshalAs(UnmanagedType.Bool)]
		private static extern bool IsWow64Process(IntPtr hProcess, [MarshalAs(UnmanagedType.Bool)] out bool isWow64);

		[DllImport("kernel32.dll", CharSet = CharSet.Auto, SetLastError = true)]
		private static extern IntPtr GetCurrentProcess();

		public static object GetRegistry(RegistryHive key, string path, string value, RegistryView regView, out bool isX86)
		{
			bool f64 = false;
			bool isWoW64 = IsWow64Process(GetCurrentProcess(), out f64) && f64;
			object obj = null;
			isX86 = false;

			if ((RegistryHive.CurrentUser == key) && (RegistryView.Registry32 == regView))
			{
				if (IntPtr.Size == 8 || isWoW64)
				{
					string[] temp = path.Split('\\');
					temp[0] = temp[0] + "\\Wow6432Node";
					path = string.Join("\\", temp);
				}
			}
			RegistryKey programName = RegistryKey.OpenBaseKey(key, regView);
			programName = programName.OpenSubKey(path);
			if (programName != null)
			{
				try
				{
					obj = programName.GetValue(value);
					if ((RegistryView.Registry32 == regView) && (null != obj))
					{
						isX86 = true;
					}
				}
				catch
				{
				}
				if (null == obj)
				{
					if (RegistryView.Registry32 == regView)
					{
						if (RegistryHive.CurrentUser == key)
						{
							path = path.Replace("\\Wow6432Node", "");
						}
						programName = RegistryKey.OpenBaseKey(key, RegistryView.Registry64);
						programName = programName.OpenSubKey(path);
						if (programName != null)
						{
							try
							{
								obj = programName.GetValue(value);
								isX86 = false;
							}
							catch
							{
							}
						}
					}
					else
					{
						if (RegistryHive.CurrentUser == key)
						{
							string[] temp = path.Split('\\');
							temp[0] = temp[0] + "\\Wow6432Node";
							path = string.Join("\\", temp);
						}
						programName = RegistryKey.OpenBaseKey(key, RegistryView.Registry32);
						programName = programName.OpenSubKey(path);
						if (programName != null)
						{
							try
							{
								obj = programName.GetValue(value);
								isX86 = true;
							}
							catch
							{
							}
						}
					}
				}
			}
			return obj;
		}

		public static bool SetRegistry(RegistryHive key, string path, string name, object value, RegistryView regView)
		{
			RegistryKey createKey;

			if ((RegistryHive.CurrentUser == key) && (RegistryView.Registry32 == regView))
			{
				string[] temp = path.Split('\\');
				temp[0] = temp[0] + "\\Wow6432Node";
				path = string.Join("\\", temp);
			}

			try
			{
				createKey = RegistryKey.OpenBaseKey(key, regView);
				createKey = createKey.CreateSubKey(path);
				createKey.SetValue(name, value);
				createKey.Close();
				return true;
			}
			catch
			{
				return false;
			}
		}

		public static bool DeleteRegistry(RegistryHive key, string path, string name, RegistryView regView, bool isKey)
		{
			RegistryKey createKey;

			if ((RegistryHive.CurrentUser == key) && (RegistryView.Registry32 == regView))
			{
				string[] temp = path.Split('\\');
				temp[0] = temp[0] + "\\Wow6432Node";
				path = string.Join("\\", temp);
			}

			try
			{
				createKey = RegistryKey.OpenBaseKey(key, regView);
				createKey = createKey.OpenSubKey(path, true);

				if (null == createKey)
				{
				}
				else
				{
					if (isKey)
					{
						createKey.DeleteSubKeyTree(name);
						createKey.Close();
					}
					else
					{
						createKey.DeleteValue(name);
						createKey.Close();
					}
				}

				return true;
			}
			catch (Exception ex)
			{
				LogtoFile.WriteLog("", Configs.DebugLevelValue, ex.ToString(), "");
				return false;
			}
		}
	}
}