﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Security;
using System.Text;
using System.Windows.Forms;

namespace AirFusion
{
	public static partial class Win32Api
	{
		internal const int WM_DISPLAYCHANGE = 0x007E;
		internal const int WM_CHAR = 0x0102;
		internal const int WM_DEADCHAR = 0x0103;
		internal const int WM_DESTROY = 0x0002;
		internal const int WM_KEYDOWN = 0x0100;
		internal const int WM_KEYUP = 0x0101;
		internal const int WM_LBUTTONDBLCLK = 0x0203;
		internal const int WM_LBUTTONDOWN = 0x0201;
		internal const int WM_LBUTTONUP = 0x0202;
		internal const int WM_MBUTTONDBLCLK = 0x0209;
		internal const int WM_MBUTTONDOWN = 0x0207;
		internal const int WM_MBUTTONUP = 0x0208;
		internal const int WM_MOUSEACTIVATE = 0x0021;
		internal const int WM_MOUSEMOVE = 0x0200;
		internal const int WM_MOUSELEAVE = 0x02A3;
		internal const int WM_NCLBUTTONDBLCLK = 0x00A3;
		internal const int WM_NCLBUTTONDOWN = 0x00A1;
		internal const int WM_NCLBUTTONUP = 0x00A2;
		internal const int WM_NCMBUTTONDBLCLK = 0x00A9;
		internal const int WM_NCMBUTTONDOWN = 0x00A7;
		internal const int WM_NCMBUTTONUP = 0x00A8;
		internal const int WM_NCMOUSEMOVE = 0x00A0;
		internal const int WM_NCRBUTTONDBLCLK = 0x00A6;
		internal const int WM_NCRBUTTONDOWN = 0x00A4;
		internal const int WM_NCRBUTTONUP = 0x00A5;
		internal const int WM_RBUTTONDBLCLK = 0x0206;
		internal const int WM_RBUTTONDOWN = 0x0204;
		internal const int WM_RBUTTONUP = 0x0205;
		internal const int WM_SYSCHAR = 0x0106;
		internal const int WM_SYSDEADCHAR = 0x0107;
		internal const int WM_SYSKEYDOWN = 0x0104;
		internal const int WM_SYSKEYUP = 0x0105;
		internal const int WM_IME_CHAR = 0x0286;
		internal const int WM_IME_COMPOSITION = 0x010F;
		internal const int WM_IME_SETCONTEXT = 0x0281;
		internal const int WM_IME_NOTIFY = 0x0282;
		internal const int WM_INPUTLANGCHANGE = 0x0051;
		internal const int WM_USER = 0x0400;
		internal const int WM_BADNETWORK = WM_USER + 1000;
		internal const int WM_GOODNETWORK = WM_USER + 1001;
		internal const int WM_CHECKRECEIVEDATA = WM_USER + 1002;
		internal const int WM_TCPDisconnected = WM_USER + 1003;
		internal const int WM_ForceExit = WM_USER + 2000;
		internal const int WM_ShowUp = WM_USER + 2001;

		internal const int VK_RETURN = 0x0d;	// Virtual-Key Code: ENTER key
		internal const int VK_BACK = 0x08;		// Virtual-Key Code: BACKSPACE key

		[DllImport("Imm32.dll")]
		public static extern IntPtr ImmGetContext(IntPtr hWnd);

		[DllImport("Imm32.dll")]
		public static extern IntPtr ImmAssociateContext(IntPtr hWnd, IntPtr hIMC);

		[DllImport("imm32.dll", CharSet = CharSet.Auto)]
		public static extern int ImmReleaseContext(int hWnd, int hImc);

		[DllImport("imm32.dll", CharSet = CharSet.Auto)]
		public static extern int ImmGetConversionStatus(IntPtr hImc, out int fdwConversion, out int fdwSentence);

		[DllImport("user32.dll")]
		public static extern int GetKeyboardLayoutName([Out] StringBuilder pwszKLID);

		internal const int KL_NAMELENGTH = 9;
		internal const string ENGLISH_US_LAYOUTNAME = "00000409";
		internal const int IME_CMODE_NATIVE = 1;

		[DllImport("gdi32.dll")]
		public static extern int GetDeviceCaps(IntPtr hdc, int Index);

		[DllImport("user32.dll")]
		public static extern IntPtr GetDC(IntPtr hwnd);

		[StructLayout(LayoutKind.Sequential, CharSet = CharSet.Unicode)]
		internal struct MyStruct
		{
			[MarshalAs(UnmanagedType.ByValTStr, SizeConst = 256)]
			public string Message;
		}

		internal const int WM_DATA = 0x004A;

		[StructLayout(LayoutKind.Sequential)]
		internal struct COPYDATASTRUCT
		{
			public IntPtr dwData;       // Specifies data to be passed
			public int cbData;          // Specifies the data size in bytes
			public IntPtr lpData;       // Pointer to data to be passed
		}

		[SuppressUnmanagedCodeSecurity]
		internal class NativeMethod
		{
			[DllImport("user32.dll", CharSet = CharSet.Auto, SetLastError = true)]
			public static extern IntPtr SendMessage(IntPtr hWnd, int Msg, IntPtr wParam, ref COPYDATASTRUCT lParam);

			[DllImport("user32.dll", CharSet = CharSet.Auto, SetLastError = true)]
			public static extern int PostMessage(IntPtr hWnd, int msg, IntPtr wParam, IntPtr lParam);

			[DllImport("user32.dll", CharSet = CharSet.Auto, SetLastError = true)]
			public static extern IntPtr FindWindow(string lpClassName, string lpWindowName);

			//Johnon 0716 add for use Win32 api about GetForegroundWindow()
			/// <summary>The GetForegroundWindow function returns a handle to the foreground window.</summary>
			[DllImport("user32.dll")]
			public static extern IntPtr GetForegroundWindow();

            [DllImport("user32.dll", SetLastError = true)]
            public static extern int GetWindowLong(IntPtr hWnd, int nIndex);
		}

		public static readonly Guid Downloads = new Guid("374DE290-123F-4565-9164-39C4925E467B");

		[DllImport("shell32.dll", CharSet = CharSet.Unicode)]
		public static extern int SHGetKnownFolderPath([MarshalAs(UnmanagedType.LPStruct)] Guid rfid, uint dwFlags, IntPtr hToken, out string pszPath);

		[DllImport("secur32.dll", CharSet = CharSet.Auto)]
		public static extern int GetUserNameEx(int nameFormat, StringBuilder userName, ref int userNameSize);
	}

	internal enum EXTENDED_NAME_FORMAT
	{
		NameUnknown = 0,
		NameFullyQualifiedDN = 1,
		NameSamCompatible = 2,
		NameDisplay = 3,
		NameUniqueId = 6,
		NameCanonical = 7,
		NameUserPrincipal = 8,
		NameCanonicalEx = 9,
		NameServicePrincipal = 10,
		NameDnsDomain = 12
	}
}