﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Threading;
using AirFusion;
using AirFusion.WebService;
using AirFusion.Common;
using AirFusion.Manager;
using AirFusion.Manager.DeviceManager;

namespace AirFusion
{
	/// <summary>
	/// Interaction logic for TwoButtonDlg.xaml
	/// </summary>
	public partial class TwoButtonDlg : UserControl
	{
		#region Events

		public event EventHandler<UserControlEventArgs> UserControlEvent;

		#endregion

		#region Properties

		private AFUserDevice _targetDevice = null;
		public AFUserDevice TargetDevice
		{
			get 
			{
				return _targetDevice;
			}

			set 
			{
				_targetDevice = value;
			}
		}

		private UserControlEventType _commandType = UserControlEventType.None;
		public UserControlEventType CommandType 
		{
			get 
			{
				return _commandType;
			}

			set 
			{
				_commandType = value;
			}
		}

		#endregion

		#region Constructor & Dispose

		public TwoButtonDlg()
		{
			InitializeComponent();
		}

		#endregion

		#region Private Methods

		private void ResetMessage() 
		{
			this.CommandType = UserControlEventType.None;
			this.TargetDevice = null;
			this.txtDialogTitle.Text = string.Empty;
			this.txtDialogDetail.Text = string.Empty;
			this.imgPresent.Source = null;
		}

		#endregion

		#region UI Event Callbacks

		private void btnLeft_Click(object sender, RoutedEventArgs e)
		{
			if (null != this.UserControlEvent)
			{
				this.UserControlEvent(this, new UserControlEventArgs(this.CommandType, _targetDevice, true));
			}

			this.ResetMessage();
		}

		private void btnRight_Click(object sender, RoutedEventArgs e)
		{
			if (null != this.UserControlEvent)
			{
				this.UserControlEvent(this, new UserControlEventArgs(this.CommandType, _targetDevice, false));
			}

			this.ResetMessage();
		}

		#endregion
	}
}
