﻿using System;
using System.Collections.Generic;
using System.Windows.Media.Imaging;

namespace AirFusionCustomNotification
{
	class CustomNotificationViewModel
	{
		private CustomNotificationView _cNView;

		public struct DynamicButtonStruct
		{
			public string Name;
			public Action Action;
		}

		public struct CustomNotificationElement
		{
			public string NotificationWidth;
			public string NotificationHeight;
			public BitmapSource NotificationIcon;
			public string NotificationTitle;
			public string NotificationContent;
			public string NotificationInfomation;
			public string TimeToCloseNotification;
			public string NotificationKey;
			public List<DynamicButtonStruct> _dynamicButtonsList;
		}

		public void CreatCustomNotification(CustomNotificationElement CNElement)
		{
			if (this._cNView == null)
				this._cNView = new CustomNotificationView();

			this._cNView.NotificationWidth = CNElement.NotificationWidth;
			this._cNView.NotificationHeight = CNElement.NotificationHeight;
			this._cNView.NotificationIcon = CNElement.NotificationIcon;
			this._cNView.NotificationTitle = CNElement.NotificationTitle;
			this._cNView.NotificationContent = CNElement.NotificationContent;
			this._cNView.NotificationInfomation = CNElement.NotificationInfomation;
			this._cNView.TimeToCloseNotification = CNElement.TimeToCloseNotification;
			this._cNView.NotificationKey = CNElement.NotificationKey;

			if (CNElement._dynamicButtonsList != null && CNElement._dynamicButtonsList.Count > 0)
			{
				foreach (DynamicButtonStruct _dynamicButton in CNElement._dynamicButtonsList)
				{
					this._cNView.RefreshDynamicButtonField(_dynamicButton.Name, _dynamicButton.Action);
				}
			}

			this._cNView.Show();
		}

		public void CloseCustomNotification()
		{
			if (this._cNView != null)
				this._cNView.Close();
		}
	}
}
