﻿namespace AirFusion.Manager.DeviceManager
{
	public partial class DnsSdHandler
	{
		/// <summary>
		/// Represents the methods that will handle the callback of RegisterService().
		/// </summary>
		/// <param name="args">The <see cref="RegistrarCallbackArgs"/> instance containing the callback arguments.</param>
		public delegate void RegistrarCallback(RegistrarCallbackArgs args);

		/// <summary>
		/// Represents the methods that will handle the callback of StartBrowseService().
		/// </summary>
		/// <param name="args">The <see cref="BrowserCallbackArgs"/> instance containing the callback arguments.</param>
		public delegate void BrowserCallback(BrowserCallbackArgs args);
 
		/// <summary>
		/// Represents the methods that will handle the callback of StartResolveService().
		/// </summary>
		/// <param name="args">The <see cref="ResolverCallbackArgs"/> instance containing the callback arguments.</param>
		public delegate void ResolverCallback(ResolverCallbackArgs args);

		/// <summary>
		/// Represents the methods that will handle the callback of StartQueryRecord().
		/// </summary>
		/// <param name="args">The <see cref="RecordQuerierCallbackArgs"/> instance containing the callback arguments.</param>
		public delegate void RecordQuerierCallback(RecordQuerierCallbackArgs args);

		/// <summary>
		/// Represents the methods that will handle the callback of StartQueryAddress().
		/// </summary>
		/// <param name="args">The <see cref="AddressQuerierCallbackArgs"/> instance containing the callback arguments.</param>
		public delegate void AddressQuerierCallback(AddressQuerierCallbackArgs args);
	}
}
