﻿using AirFusion.Common;
using InTheHand.Net;
using Newtonsoft.Json;
using System;
using System.Diagnostics;
using System.Net;
using System.Net.Http;
using System.Text;
using System.Threading;

namespace AirFusion.WebService.Adapters
{
	internal partial class DeviceInformation
	{
		/// <summary>
		/// Represents the display information of Bluetooth.
		/// </summary>
		public partial class BluetoothInfo
		{
			/// <summary>
			/// Gets or sets the address of the Bluetooth radio.
			/// </summary>
			[JsonProperty("Address"), JsonConverter(typeof(AirFusion.Common.JsonConverters.BluetoothAddressConverter))]
			public BluetoothAddress Address { get; internal set; }

			#region Private/Protected/Internal

			/// <summary>
			/// Initializes a new instance of the <see cref="BluetoothInfo"/> class.
			/// </summary>
			internal BluetoothInfo()
			{
				this.Address = null;
			}

			#endregion Private/Protected/Internal

			#region Override

			/// <summary>
			/// Returns a <see cref="System.String" /> that represents this instance.
			/// </summary>
			/// <returns>
			/// A <see cref="System.String" /> that represents this instance.
			/// </returns>
			public override string ToString()
			{
				StringBuilder builder = new StringBuilder();
				builder.AppendLine(this.GetType().GetFullName() + ".Address: " + (this.Address != null ? "\r\n" + this.Address.GetStringFormat() : "N/A"));

				return builder.ToString().TrimEnd();
			}

			#endregion Override
		}
	}
}