﻿using AirFusion.Common;
using Newtonsoft.Json;
using System.Text;

namespace AirFusion.WebService.Adapters
{
	internal partial class DeviceInformation
	{
		public partial class ServicesInfo
		{
			/// <summary>
			/// Represents the information of input control service.
			/// </summary>
			public class InputControlInfo
			{
				/// <summary>
				/// Gets the port number of input control.
				/// </summary>
				/// <remarks>
				/// Current, this property states the port number of VNC server.
				/// </remarks>
				[JsonProperty("Port")]
				public ushort? Port { get; internal set; }

				#region Private/Protected/Internal

				/// <summary>
				/// Initializes a new instance of the <see cref="InputControlInfo"/> class.
				/// </summary>
				internal InputControlInfo()
				{
					this.Port = null;
				}

				#endregion Private/Protected/Internal

				#region Override

				/// <summary>
				/// Returns a <see cref="System.String" /> that represents this instance.
				/// </summary>
				/// <returns>
				/// A <see cref="System.String" /> that represents this instance.
				/// </returns>
				public override string ToString()
				{
					StringBuilder builder = new StringBuilder();
					builder.AppendLine(this.GetType().GetFullName() + ".Port: " + (this.Port.HasValue ? this.Port.Value.ToString() : "N/A"));

					return builder.ToString().TrimEnd();
				}

				#endregion Override
			}
		}
	}
}
