﻿using System.Net.Http;

namespace AirFusion.WebService
{
	/// <summary>
	/// Represents a web service remote response filter.
	/// </summary>
	public abstract class WebServiceRemoteResponseFilter : IWebServiceResponseFilter
	{
		/// <summary>
		/// Filters a local request.
		/// </summary>
		/// <param name="responseMessage">The response message, any modification could be made to this instance.</param>
		/// <returns>True if to continue next filters.</returns>
		/// <remarks>The exception thrown by this method should be considered as an error response to be propagated.</remarks>
		public abstract bool Filter(HttpResponseMessage responseMessage);
	}
}
