﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AirFusion.WebService
{
	public sealed partial class WebServicesManager
	{
		/// <summary>
		/// Specifies the expected content type of payload.
		/// </summary>
		public enum ExpectedPayloadContentType
		{
			/// <summary>
			/// Signifies no content.
			/// </summary>
			None = 0,

			/// <summary>
			/// Signifies the string content.
			/// </summary>
			StringContent,

			/// <summary>
			/// Signifies the byte array content.
			/// </summary>
			ByteArrayContent,

			/// <summary>
			/// Signifies the stream content.
			/// </summary>
			StreamContent
		}
	}
}
