@ECHO off

pushd %~dp0

SET ReleaseFolder=%~1
SET SolutionFolder=%~2
SET ProjectName=%~3
SET ConfigurationName=%~4
SET PlatformName=%~5

ECHO ReleaseFolder=%ReleaseFolder%
ECHO SolutionFolder=%SolutionFolder%
ECHO ProjectName=%ProjectName%
ECHO ConfigurationName=%ConfigurationName%
ECHO PlatformName=%PlatformName%

SET ReleaseFolder=%SolutionFolder%\bin_Win32
IF "%ConfigurationName%"=="Debug" SET ReleaseFolder=%SolutionFolder%\bin_Win32d

SET FinalReleaseFolder=%SolutionFolder%\..\FinalRelease\AE\%ConfigurationName%\X86

SET NativeDLL=%SolutionFolder%\..\NativeDLL\[%ConfigurationName%]\X86\AE

ECHO ReleaseFolder=%ReleaseFolder%
ECHO FinalReleaseFolder=%FinalReleaseFolder%

:CopyToFinalReleaseFolder
REM Create folders
IF NOT EXIST "%FinalReleaseFolder%" mkdir "%FinalReleaseFolder%"
IF NOT EXIST "%NativeDLL%" mkdir "%NativeDLL%"

REM Create exclusion list
ECHO exclusion.txt>exclusion.txt
ECHO \baseclasses\>>exclusion.txt
ECHO \Demuxers\>>exclusion.txt
ECHO \DSUtilLite\>>exclusion.txt
ECHO \IntelQuickSyncDecoder\>>exclusion.txt
ECHO \LAVAudio\>>exclusion.txt
ECHO \LAVSplitter\>>exclusion.txt
ECHO \LAVVideo\>>exclusion.txt
ECHO \lib\>>exclusion.txt
ECHO \libbluray\>>exclusion.txt
ECHO .exe>>exclusion.txt
ECHO .exp>>exclusion.txt
ECHO .lib>>exclusion.txt
ECHO .pdb>>exclusion.txt
ECHO .grf>>exclusion.txt
ECHO .ilk>>exclusion.txt
ECHO LAVAudio.ax>>exclusion.txt
ECHO LAVSplitter.ax>>exclusion.txt
ECHO LAVVideo.ax>>exclusion.txt

REM Copy the output folder to final release folder
xcopy "%ReleaseFolder%." "%FinalReleaseFolder%" /E /Y /I /F /EXCLUDE:exclusion.txt

REM Copy the output folder to NativeDLL folder
xcopy "%ReleaseFolder%." "%NativeDLL%" /E /Y /I /F /EXCLUDE:exclusion.txt

REM Delete exclusion list
DEL /F exclusion.txt

popd
EXIT